package cn.iocoder.yudao.module.member.enums;

import com.google.common.collect.Sets;

import java.util.Set;

public enum ScoreSourceTypeEnum {
    MANUAL_OPERATE(1, "人工操作", null, null),

    EXCHANGE_REWARD(2, "兑换礼品", ScoreOperateTypeEnum.REDUCE, null),

    SYSTEM_EXPIRED(3, "系统失效", ScoreOperateTypeEnum.REDUCE, null),

    EXCHANGE_REWARD_CANCEL(4, "兑换礼品撤销", ScoreOperateTypeEnum.ADD, EXCHANGE_REWARD),
    ;

    private final int value;

    private final String name;

    private final ScoreOperateTypeEnum operateType;

    private final ScoreSourceTypeEnum reverseSource;
    ScoreSourceTypeEnum(int value, String name, ScoreOperateTypeEnum operateType, ScoreSourceTypeEnum reverseSource) {
        this.value = value;
        this.name = name;
        this.operateType = operateType;
        this.reverseSource = reverseSource;
    }

    public int getValue() {
        return value;
    }


    public ScoreSourceTypeEnum getReverseSource() {
        return reverseSource;
    }

    public String getName() {
        return name;
    }

    public ScoreOperateTypeEnum getOperateType() {
        return operateType;
    }

    public static Set<ScoreSourceTypeEnum> getInvalidScoreStatusSourceType() {
        return Sets.newHashSet(MANUAL_OPERATE, SYSTEM_EXPIRED);
    }
}
