package cn.iocoder.yudao.module.member.api.user;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.module.member.api.user.dto.UserRespDTO;
import cn.iocoder.yudao.module.member.api.user.dto.UserSelectReqVO;
import cn.iocoder.yudao.module.member.convert.user.UserConvert;
import cn.iocoder.yudao.module.member.dal.dataobject.user.MemberUserDO;
import cn.iocoder.yudao.module.member.service.user.MemberUserService;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;

/**
 * 会员用户的 API 实现类
 *
 * @author 捷道源码
 */
@Service
@Validated
public class MemberUserApiImpl implements MemberUserApi {

    @Resource
    private MemberUserService userService;

    @Override
    public UserRespDTO getUser(Long id) {
        MemberUserDO user = userService.info(id);
        return UserConvert.INSTANCE.convert2(user);
    }

    @Override
    public UserRespDTO getUserByMobile(String mobile) {
        MemberUserDO user = userService.getUserByMobile(mobile);
        return UserConvert.INSTANCE.convert2(user);
    }

    @Override
    public PageResult<UserRespDTO> getUserList(UserSelectReqVO userSelectReqVO) {
        PageResult<MemberUserDO> memberUserDOS = userService.selectList(userSelectReqVO);
        return UserConvert.INSTANCE.converUserRespDTO(memberUserDOS);
    }

    @Override
    public void updateMemberUserDealStatus(Long customerId, Integer customerStatus) {
        userService.updateMemberUserDealStatus(customerId, customerStatus);
    }
}
