package cn.iocoder.yudao.module.member.controller.app.auth.vo;

import cn.iocoder.yudao.framework.common.validation.InEnum;
import cn.iocoder.yudao.framework.common.validation.Mobile;
import cn.iocoder.yudao.module.system.enums.sms.SmsSceneEnum;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.experimental.Accessors;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;

/**
 * @author Administrator
 */
@ApiModel("用户 APP - 发送手机验证码 Response VO")
@Data
@Accessors(chain = true)
public class AppAuthSendSmsReqVO {

    @ApiModelProperty(value = "手机号", example = "15601691234")
    @NotBlank(message = "{app.auth.mobile.not.blank}")
    //@Mobile(message = "{app.auth.mobile.format.err}")
//    @Mobile(message = "incorrect mobile number")
    private String mobile;

    @ApiModelProperty(value = "发送场景(0注册1登录2修改手机3忘记密码)", example = "1", notes = "对应 SmsSceneEnum 枚举")
    @NotNull(message = "{app.sms.scene.not.blank}")
    @InEnum(value = SmsSceneEnum.class, message = "{app.sms.scene.not.range}")
    private Integer scene;

    @ApiModelProperty(value = "区号", required = true)
    @NotNull(message = "区号不能为空")
    private String areaCode;
}
