package cn.iocoder.yudao.module.member.controller.app.user.vo;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.format.annotation.DateTimeFormat;

import javax.validation.constraints.NotNull;

import java.util.Date;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;

@ApiModel("用户 APP - 用户个人信息 Response VO")
@Data
@NoArgsConstructor
@AllArgsConstructor
public class AppUserInfoRespVO {
    @ApiModelProperty(value = "编号", required = true)
    @NotNull(message = "编号不能为空")
    private Long id;

    @ApiModelProperty(value = "用户昵称", required = true, example = "芋艿")
    private String nickname;

    @ApiModelProperty(value = "用户头像", required = true, example = "/infra/file/get/35a12e57-4297-4faa-bf7d-7ed2f211c952")
    private String avatar;

    @ApiModelProperty(value = "生日", required = true, example = "22-7-10 下午6:15")
    @JsonFormat(pattern = "yyyy-MM-dd")
    private String birthday;

    @ApiModelProperty(value = "部门", required = true, example = "It部门")
    private String department;

    @ApiModelProperty(value = "性别：0 女 1 男 2 保密", required = true, example = "1")
    private Integer gender;

    @ApiModelProperty(value = "手机号", required = true)
    private String mobile;

    @ApiModelProperty(value = "区号", required = true)
    private String areaCode;

    @ApiModelProperty(value = "英文名称", required = true)
    private String englishName;

    @ApiModelProperty(value = "工作职位", required = true, example = "技术经理")
    private String jobPosition;

    @ApiModelProperty(value = "地址", required = true, example = "武汉市洪山区")
    private String address;

    @ApiModelProperty(value = "是否有密码")
    private Boolean isHavePassword;

    @ApiModelProperty(value = "最后登录时间")
    @DateTimeFormat(pattern = FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND)
    private Date loginDate;

    @ApiModelProperty(value = "邮箱")
    private String email;

    @ApiModelProperty(value = "是否简单密码", example = "false")
    private Boolean isSimplePassword = Boolean.FALSE;

}
