package cn.iocoder.yudao.module.member.vo.member;

import com.fasterxml.jackson.annotation.JsonFormat;
import lombok.*;
import io.swagger.annotations.*;
import org.springframework.format.annotation.DateTimeFormat;

import javax.validation.constraints.*;
import java.util.Date;

import static cn.iocoder.yudao.framework.common.util.date.DateUtils.*;

@ApiModel("管理后台 - 用户更新 Request VO")
@Data
@ToString(callSuper = true)
public class MemberUpdateReqVO{

    @ApiModelProperty(value = "编号", required = true)
    @NotNull(message = "编号不能为空")
    private Long id;

    @ApiModelProperty(value = "用户昵称", required = true)
    @NotNull(message = "用户昵称不能为空")
    private String nickname;

   /* @ApiModelProperty(value = "手机号", required = true)
    @NotNull(message = "手机号不能为空")
    private String mobile;*/

   /* @ApiModelProperty(value = "区号", required = true)
    @NotNull(message = "区号不能为空")
    private String areaCode;*/

    @ApiModelProperty(value = "英文名称", required = true)
    @NotNull(message = "英文名称不能为空")
    private String englishName;

    @ApiModelProperty(value = "生日")
    @JsonFormat(pattern = FORMAT_YEAR_MONTH_DAY)
    private Date birthday;

    @ApiModelProperty(value = "部门")
    private String department;

    @ApiModelProperty(value = "性别：0 女 1 男 2 保密")
    private Integer gender;

    @ApiModelProperty(value = "工作职位")
    private String jobPosition;

    @ApiModelProperty(value = "地址")
    private String address;

}
